Index: base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java
===================================================================
--- base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java	(revision 2471)
+++ base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java	(working copy)
@@ -637,32 +637,26 @@
     /**
      * Creates a Certificate template.
      */
-    public static X509CertInfo createX509CertInfo(KeyPair pair,
-            int serialno, String issuername, String subjname, 
-            Date notBefore, Date notAfter)
-        throws IOException, 
-                CertificateException, 
-                InvalidKeyException {
+	public static X509CertInfo createX509CertInfo(KeyPair pair,
+			BigInteger serialno, String issuername, String subjname,
+			Date notBefore, Date notAfter) throws IOException,
+			CertificateException, InvalidKeyException {
         return createX509CertInfo(convertPublicKeyToX509Key(pair.getPublic()), 
                 serialno, issuername, subjname, notBefore, notAfter);
     }
 
-    public static X509CertInfo createX509CertInfo(PublicKey publickey,
-            int serialno, String issuername, String subjname, 
-            Date notBefore, Date notAfter)
-        throws IOException, 
-                CertificateException, 
-                InvalidKeyException {
+	public static X509CertInfo createX509CertInfo(PublicKey publickey,
+			BigInteger serialno, String issuername, String subjname,
+			Date notBefore, Date notAfter) throws IOException,
+			CertificateException, InvalidKeyException {
         return createX509CertInfo(convertPublicKeyToX509Key(publickey), serialno,
                 issuername, subjname, notBefore, notAfter);
     }
 
-    public static X509CertInfo createX509CertInfo(X509Key x509key,
-            int serialno, String issuername, String subjname, 
-            Date notBefore, Date notAfter)
-        throws IOException, 
-                CertificateException, 
-                InvalidKeyException {
+	public static X509CertInfo createX509CertInfo(X509Key x509key,
+			BigInteger serialno, String issuername, String subjname,
+			Date notBefore, Date notAfter) throws IOException,
+			CertificateException, InvalidKeyException {
         // set default; use the other call with "alg" to set algorithm
         String alg = "SHA256withRSA";
         try {
@@ -673,13 +667,10 @@
         }
     }
 
-    public static X509CertInfo createX509CertInfo(X509Key x509key,
-            int serialno, String issuername, String subjname, 
-            Date notBefore, Date notAfter, String alg)
-        throws IOException, 
-                CertificateException, 
-                InvalidKeyException,
-                NoSuchAlgorithmException {
+	public static X509CertInfo createX509CertInfo(X509Key x509key,
+			BigInteger serialno, String issuername, String subjname,
+			Date notBefore, Date notAfter, String alg) throws IOException,
+			CertificateException, InvalidKeyException, NoSuchAlgorithmException {
         X509CertInfo info = new X509CertInfo();
 
         info.set(X509CertInfo.VERSION, new
Index: base/common/src/com/netscape/cms/servlet/csadmin/CertUtil.java
===================================================================
--- base/common/src/com/netscape/cms/servlet/csadmin/CertUtil.java	(revision 2471)
+++ base/common/src/com/netscape/cms/servlet/csadmin/CertUtil.java	(working copy)
@@ -335,19 +335,19 @@
                     ICertificateAuthority.ID);
             cr = (ICertificateRepository) ca.getCertificateRepository();
             BigInteger serialNo = cr.getNextSerialNumber();
-            if (type.equals("selfsign")) {
-                CMS.debug("Creating local certificate... issuerdn=" + dn);
-                CMS.debug("Creating local certificate... dn=" + dn);
-                info = CryptoUtil.createX509CertInfo(x509key, serialNo.intValue(), dn, dn, date,
-                        date, keyAlgorithm);
-            } else { 
-                String issuerdn = config.getString("preop.cert.signing.dn", "");
-                CMS.debug("Creating local certificate... issuerdn=" + issuerdn);
-                CMS.debug("Creating local certificate... dn=" + dn);
+			if (type.equals("selfsign")) {
+				CMS.debug("Creating local certificate... issuerdn=" + dn);
+				CMS.debug("Creating local certificate... dn=" + dn);
+				info = CryptoUtil.createX509CertInfo(x509key, serialNo, dn, dn,
+						date, date, keyAlgorithm);
+			} else {
+				String issuerdn = config.getString("preop.cert.signing.dn", "");
+				CMS.debug("Creating local certificate... issuerdn=" + issuerdn);
+				CMS.debug("Creating local certificate... dn=" + dn);
 
-                info = CryptoUtil.createX509CertInfo(x509key,
-                        serialNo.intValue(), issuerdn, dn, date, date, keyAlgorithm);
-            }
+				info = CryptoUtil.createX509CertInfo(x509key, serialNo,
+						issuerdn, dn, date, date, keyAlgorithm);
+			}
             CMS.debug("Cert Template: " + info.toString());
 
             String instanceRoot = config.getString("instanceRoot");